c语言sscanf函数的用法是什么
343
2022-08-26
[leetcode] 486. Predict the Winner
Description
Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.
Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.
Example 1: Input:
[1, 5, 2]
Output:
False
Explanation:
Initially, player 1 can choose between 1 and 2. If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2). So, final score of player 1 is 1 + 2 = 3, and player 2 is 5. Hence, player 1 will never be the winner and you need to return False.
Example 2: Input:
[1, 5, 233, 7]
Output:
True
Explanation:
Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.
Note: 1 <= length of the array <= 20. Any scores in the given array are non-negative integers and will not exceed 10,000,000. If the scores of both players are equal, then player 1 is still the winner.
分析
题目的意思是:两个玩家从数组里面轮流拿数字,只能从两头取,每个人都拿数都是最优的,问最后第一个玩家能赢吗?
这里需要用到动态规划,动态规划其实可以转换为递归,下面就是递归。dp[i][j] = max(nums[i] - dp[i + 1][j], nums[j] - dp[i][j - 1]); dp[i][j]第一个玩家拿了第i个数,第二个玩家拿第j个数后,第一个玩家比第二个玩家多的分值,使它最大化。
代码
class Solution {public: bool PredictTheWinner(vector
参考文献
Leetcode 486. Predict the Winner 预测赢家 解题报告
版权声明:本文内容由网络用户投稿,版权归原作者所有,本站不拥有其著作权,亦不承担相应法律责任。如果您发现本站中有涉嫌抄袭或描述失实的内容,请联系我们jiasou666@gmail.com 处理,核实后本网站将在24小时内删除侵权内容。
发表评论
暂时没有评论,来抢沙发吧~